module(...,package.seeall)
require "pm"        --Power management
require "utils"  
require "pins"
pmd.ldoset(2,pmd.LDO_VLCD)
local level = 1
local gpio_1 = pins.setup(pio.P0_1, 1)
local gpio_4 = pins.setup(pio.P0_4, 1)
local gpio_5 = pins.setup(pio.P0_5, 1)
function gpioInt_9(msg)
    if msg == cpu.INT_GPIO_POSEDGE then
        log.warn("使用了pm.wake()来使系统唤醒")
        pm.wake("TEST")
    else
        log.warn("使用了pm.slepp()来使系统休眠")
        pm.sleep("TEST")
    end
end
pin9 = pins.setup(pio.P0_9, gpioInt_9)
sys.timerStart(function() if pin9() == 1 then pm.wake("TEST") end end, 500)   
local UART_ID = 2          
local function taskRead()   
    while true do
        local data = uart.read(UART_ID, "*l")
        if not data or string.len(data) ==  0 then break end
        if string.match(data, "GPIO_TEST") then
            level = level == 1 and 0 or 1
            gpio_1(level)
            gpio_4(level)
            gpio_5(level)
        end
    end
end
uart.on(UART_ID, "receive", taskRead)
uart.setup(UART_ID, 115200, 8, uart.PAR_NONE, uart.STOP_1)
sys.taskInit(
    function()
        while true do 
            print("\"TEST\"的休眠状态：",pm.isSleep("TEST"),"全局的休眠状态：",pm.isSleep())
        	sys.wait(1000)
        end
    end
)
